//+------------------------------------------------------------------+
//|                                                Geo_Fractal3.mq4  |
//|                                         Copyright  2011, Geokom |
//|                                             geokom2004@yandex.ru |
//+------------------------------------------------------------------+
//                      
//                      
// Geo_Fractal3.mq4 -          
// 28022012 Geo_Fractal3.mq4 -           
// 



#property copyright "Copyright  2011, Geokom"
#property link      "geokom2004@yandex.ru"
#property indicator_chart_window



extern   int     MA_TF1 = PERIOD_D1;
extern   int     MA_TF2 = PERIOD_H4;
extern   int     MA_TF3 = PERIOD_H1;
extern   int     MA_TF4 = PERIOD_M15;
extern   bool    UseShift = true;

   bool    ReDraw =  true ;


       double FrLowD1=0;
       double FrUpD1=0;
       double FrLowH4=0;
       double FrUpH4=0;
       double FrLowH1=0;
       double FrUpH1=0;
       double FrLowM15=0;
       double FrUpM15=0;

double C,O,H,L, SPR ;
string CommentString;
int k;

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
void DrawLine (string LineName, bool magnet , datetime Time1,double Price1, datetime Time2,double Price2, bool draw, color LineColor, int LineStyle, bool TrendLine, bool Ray)   //   .     .    -  .
   {
      if (ObjectFind(LineName)==0)
      {
         if(!draw)  {ObjectDelete(LineName);return;}
         
         if (magnet && ObjectGet(LineName,OBJPROP_TIME1) != Time1) 
         {
         ObjectSet(LineName,OBJPROP_TIME1,Time1);
         }
         if (magnet && ObjectGet(LineName,OBJPROP_PRICE1) != Price1) 
         {
         ObjectSet(LineName,OBJPROP_PRICE1,Price1);
         }
         
         if (TrendLine)
         {         
         
            if (magnet && ObjectGet(LineName,OBJPROP_TIME2) != Time2) 
            {
            ObjectSet(LineName,OBJPROP_TIME2,Time2);
            }
            if (magnet && ObjectGet(LineName,OBJPROP_PRICE2) != Price2) 
            {
            ObjectSet(LineName,OBJPROP_PRICE2,Price2);
            }
         }         
       ObjectSet(LineName,OBJPROP_COLOR,LineColor);
       ObjectSet(LineName,OBJPROP_STYLE,LineStyle);
       ObjectSet(LineName,OBJPROP_RAY,Ray);

      }
      
      if (ObjectFind(LineName)!=0&&draw)
      {
         if (!TrendLine)
         {
           ObjectCreate (LineName,OBJ_HLINE,0,0,Price1,0);
         }

         if (TrendLine)
         {       
           ObjectCreate (LineName,OBJ_TREND,0,Time1,Price1,Time2,Price2);
           ObjectSet(LineName,OBJPROP_RAY,Ray);
         }
      
      ObjectSet(LineName,OBJPROP_COLOR,LineColor);
      ObjectSet(LineName,OBJPROP_STYLE,LineStyle);
      }
      return;
   }   


//+------------------------------------------------------------------+  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+

  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {

int limit;
int counted_bars=IndicatorCounted();
//    -   ,   
if(counted_bars<0) return(-1);
//  
if(counted_bars>0) counted_bars--;
limit=Bars-counted_bars;

     if ( SPR ==0)    { SPR  = MarketInfo(Symbol(),MODE_SPREAD);}
     
     if (Digits ==2 || Digits ==4) {k = 10;}
     if (Digits ==3 || Digits ==5) {k = 1;}

     double LowShift =  0;
     double HighShift = 0;
     
     if (UseShift){ 
     LowShift = 10 *Point / k;
     HighShift = SPR*Point + 10*Point / k;
     } 
//=============================================================================================
//    D1 =======================================================================
        FrLowD1=0;
        FrUpD1=0;

       for (int f=1;f<50;f++) //  ( f=1 -  1   )
       {
       if ((FrLowD1==0)&&(iFractals(NULL, MA_TF1, MODE_LOWER,f)!=0))
       {FrLowD1=iFractals(NULL, MA_TF1, MODE_LOWER,f);int fld1=f;
       DrawLine("FrLowD1" ,ReDraw   , iTime(NULL, MA_TF1,fld1), FrLowD1-LowShift,2*TimeCurrent() - iTime(NULL, 0,10), FrLowD1-LowShift, true, Red, 4, true, false );} //    
       
       if ((FrUpD1==0)&&(iFractals(NULL, MA_TF1, MODE_UPPER,f)!=0)) 
       {FrUpD1=iFractals(NULL, MA_TF1, MODE_UPPER,f);int fud1=f;
       DrawLine("FrUpD1" ,ReDraw  , iTime(NULL, MA_TF1,fud1), FrUpD1+HighShift,2*TimeCurrent() - iTime(NULL, 0,10), FrUpD1+HighShift, true, Blue, 4, true, false );} //    
       
       }
       
       for (int i=1;i<fld1;i++) //  
       {
         if (FrLowD1!=0)
         {
            ObjectDelete ("D1S");
            
            if (iClose(NULL, MA_TF1,i) < FrLowD1)
            {
 //            ObjectCreate("D1S", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, MA_TF1,fld1) ,FrLowD1,0,0 );
             ObjectCreate("D1S", OBJ_TEXT,  0,2*TimeCurrent() - iTime(NULL, 0,10) ,FrLowD1,0,0 );
             ObjectSetText("D1S", "D1", 10,"arial",Red);
            
             DrawLine("FrLowD1" ,ReDraw   , iTime(NULL, MA_TF1,fld1), FrLowD1-LowShift,2*TimeCurrent() - iTime(NULL, 0,10), FrLowD1-LowShift, true, Red, 0, true, false ); break;
            }
         }
       }
       for ( i=1;i<fud1;i++) //  
       {
      
         if (FrUpD1!=0)
         {
            ObjectDelete ("D1B");
         
            if (iClose(NULL, MA_TF1,i) > FrUpD1)
            {
//             ObjectCreate("D1B", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, MA_TF1,fud1) ,FrUpD1,0,0 );
             ObjectCreate("D1B", OBJ_TEXT,0, 2*TimeCurrent() - iTime(NULL, 0,10)  ,FrUpD1,0,0 );
             ObjectSetText("D1B", "D1", 10,"arial", Blue);
            
             DrawLine("FrUpD1" ,ReDraw   , iTime(NULL, MA_TF1,fud1), FrUpD1+HighShift,2*TimeCurrent() - iTime(NULL, 0,10), FrUpD1+HighShift, true, Blue, 0, true, false ); break;
            }
         }
      
        } 
      

//   D1 ============================================================================
//=============================================================================================

//=============================================================================================
//    H4 =======================================================================
        FrLowH4=0;
        FrUpH4=0;

       for ( f=1;f<50;f++) //  ( f=1 -  1   )
       {
       if ((FrLowH4==0)&&(iFractals(NULL, MA_TF2, MODE_LOWER,f)!=0))
       {FrLowH4=iFractals(NULL, MA_TF2, MODE_LOWER,f);int flh4=f;
       DrawLine("FrLowH4" ,ReDraw   , iTime(NULL, MA_TF2,flh4), FrLowH4-LowShift,2*TimeCurrent() - iTime(NULL, 0,10), FrLowH4-LowShift, true, Red, 4, true, false );} //    
       
       if ((FrUpH4==0)&&(iFractals(NULL, MA_TF2, MODE_UPPER,f)!=0)) 
       {FrUpH4=iFractals(NULL, MA_TF2, MODE_UPPER,f);int fuh4=f;
       DrawLine("FrUpH4" ,ReDraw  , iTime(NULL, MA_TF2,fuh4), FrUpH4+HighShift,2*TimeCurrent() - iTime(NULL, 0,10), FrUpH4+HighShift, true, Blue, 4, true, false );} //    
       
       }
       
       for ( i=1;i<flh4;i++) //  
       {
         if (FrLowH4!=0)
         {
            ObjectDelete ("H4S");
            if (iClose(NULL, MA_TF2,i) < FrLowH4)
            {
//             ObjectCreate("H4S", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, MA_TF2,flh4) ,FrLowH4,0,0 );
             ObjectCreate("H4S", OBJ_TEXT,0, 2*TimeCurrent() - iTime(NULL, 0,10)  ,FrLowH4,0,0 );
             ObjectSetText("H4S", "H4", 9,"arial",Red);
            
             DrawLine("FrLowH4" ,ReDraw   , iTime(NULL, MA_TF2,flh4), FrLowH4-LowShift,2*TimeCurrent() - iTime(NULL, 0,10), FrLowH4-LowShift, true, Red, 0, true, false ); break;
            }
         }
       }
       for ( i=1;i<fuh4;i++) //  
       {
      
         if (FrUpH4!=0)
         {
            ObjectDelete ("H4B");         
            if (iClose(NULL, MA_TF2,i) > FrUpH4 )
            {
//             ObjectCreate("H4B", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, MA_TF2,fuh4) ,FrUpH4,0,0 );
             ObjectCreate("H4B", OBJ_TEXT,0,  2*TimeCurrent() - iTime(NULL, 0,10)  ,FrUpH4,0,0 );
             ObjectSetText("H4B", "H4", 9,"arial", Blue);
            
             DrawLine("FrUpH4" ,ReDraw   , iTime(NULL, MA_TF2,fuh4), FrUpH4+HighShift,2*TimeCurrent() - iTime(NULL, 0,10), FrUpH4+HighShift, true, Blue, 0, true, false ); break;
            }
         }
      
        } 
      

//   H4 ============================================================================
//=============================================================================================



//=============================================================================================
//    H1 =======================================================================
        FrLowH1=0;
        FrUpH1=0;

       for ( f=1;f<50;f++) //  ( f=1 -  1   )
       {
       if ((FrLowH1==0)&&(iFractals(NULL, MA_TF3, MODE_LOWER,f)!=0))
       {FrLowH1=iFractals(NULL, MA_TF3, MODE_LOWER,f);int flh1=f;
       DrawLine("FrLowH1" ,ReDraw   , iTime(NULL, MA_TF3,flh1), FrLowH1-LowShift,2*TimeCurrent() - iTime(NULL, 0,10), FrLowH1-LowShift, true, Red, 4, true, false );} //    
       
       if ((FrUpH1==0)&&(iFractals(NULL, MA_TF3, MODE_UPPER,f)!=0)) 
       {FrUpH1=iFractals(NULL, MA_TF3, MODE_UPPER,f);int fuh1=f;
       DrawLine("FrUpH1" ,ReDraw  , iTime(NULL, MA_TF3,fuh1), FrUpH1+HighShift,2*TimeCurrent() - iTime(NULL, 0,10), FrUpH1+HighShift, true, Blue, 4, true, false );} //    
       
       }
       
       for ( i=1;i<flh1;i++) //  
       {
         if (FrLowH1!=0)
         {
            ObjectDelete ("H1S");
            if (iClose(NULL, MA_TF3,i) < FrLowH1)
            {
//             ObjectCreate("H1S", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, MA_TF3,flh1) ,FrLowH1,0,0 );
             ObjectCreate("H1S", OBJ_TEXT,0,2*TimeCurrent() - iTime(NULL, 0,10) ,FrLowH1,0,0 );
             ObjectSetText("H1S", "H1", 8,"arial",Red);
             DrawLine("FrLowH1" ,ReDraw   , iTime(NULL, MA_TF3,flh1), FrLowH1-LowShift,2*TimeCurrent() - iTime(NULL, 0,10), FrLowH1-LowShift, true, Red, 0, true, false ); break;
            }
         }
       }
       for ( i=1;i<fuh1;i++) //  
       {
      
         if (FrUpH1!=0)
         {
            ObjectDelete ("H1B");         
         
            if (iClose(NULL, MA_TF3,i) > FrUpH1)
            {
//             ObjectCreate("H1B", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, MA_TF3,fuh1) ,FrUpH1,0,0 );
             ObjectCreate("H1B", OBJ_TEXT, 0, 2*TimeCurrent() - iTime(NULL, 0,10)  ,FrUpH1,0,0 );
             ObjectSetText("H1B", "H1", 8,"arial", Blue);
             DrawLine("FrUpH1" ,ReDraw   , iTime(NULL, MA_TF3,fuh1), FrUpH1+HighShift,2*TimeCurrent() - iTime(NULL, 0,10), FrUpH1+HighShift, true, Blue, 0, true, false ); break;
            
            }
         }
      
        } 
      

//   H1 ============================================================================
//=============================================================================================


//=============================================================================================
//    M15 =======================================================================
        FrLowM15=0;
        FrUpM15=0;

       for ( f=1;f<50;f++) //  ( f=1 -  1   )
       {
       if ((FrLowM15==0)&&(iFractals(NULL, MA_TF4, MODE_LOWER,f)!=0))
       {FrLowM15=iFractals(NULL, MA_TF4, MODE_LOWER,f);int flm15=f;
       DrawLine("FrLowM15" ,ReDraw   , iTime(NULL, MA_TF4,flm15), FrLowM15-LowShift,2*TimeCurrent() - iTime(NULL, 0,10), FrLowM15-LowShift, true, Red, 4, true, false );} //    
       
       if ((FrUpM15==0)&&(iFractals(NULL, MA_TF4, MODE_UPPER,f)!=0)) 
       {FrUpM15=iFractals(NULL, MA_TF4, MODE_UPPER,f);int fum15=f;
       DrawLine("FrUpM15" ,ReDraw  , iTime(NULL, MA_TF4,fum15), FrUpM15+HighShift,2*TimeCurrent() - iTime(NULL, 0,10), FrUpM15+HighShift, true, Blue, 4, true, false );} //    
       
       }
       
       for ( i=1;i<flm15;i++) //  
       {
         if (FrLowM15!=0)
         {
            ObjectDelete ("M15S");
            if (iClose(NULL, MA_TF4,i) < FrLowM15)
            {
//             ObjectCreate("M15S", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, MA_TF4,flm15) ,FrLowM15,0,0 );
             ObjectCreate("M15S", OBJ_TEXT, 0, 2*TimeCurrent() - iTime(NULL, 0,10) ,FrLowM15,0,0 );
             ObjectSetText("M15S", "M15", 8,"arial",Red);
             DrawLine("FrLowM15" ,ReDraw   , iTime(NULL, MA_TF4,flm15), FrLowM15-LowShift,2*TimeCurrent() - iTime(NULL, 0,10), FrLowM15-LowShift, true, Red, 0, true, false ); break;
            }
         }
       }
       for ( i=1;i<fum15;i++) //  
       {
      
         if (FrUpM15!=0)
         {
            ObjectDelete ("M15B");         
         
            if (iClose(NULL, MA_TF4,i) > FrUpM15)
            {
//             ObjectCreate("M15B", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, MA_TF4,fum15) ,FrUpM15,0,0 );
             ObjectCreate("M15B", OBJ_TEXT,0, 2*TimeCurrent() - iTime(NULL, 0,10) ,FrUpM15,0,0 );
             ObjectSetText("M15B", "M15", 8,"arial", Blue);
             DrawLine("FrUpM15" ,ReDraw   , iTime(NULL, MA_TF4,fum15), FrUpM15+HighShift,2*TimeCurrent() - iTime(NULL, 0,10), FrUpM15+HighShift, true, Blue, 0, true, false ); break;
            
            }
         }
      
        } 
      

//   M15 ============================================================================
//=============================================================================================


   return(0);
}
//+------------------------------------------------------------------+